// Agent.h: interface for the Agent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AGENT_H__76D069E2_07DB_11D5_A2B5_E082D8D8734D__INCLUDED_)
#define AFX_AGENT_H__76D069E2_07DB_11D5_A2B5_E082D8D8734D__INCLUDED_

#include "Inventory.h"
#include <Iostream.h>
#include <Stdlib.h>
#include "Product.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Agent  
{
public:
	Agent();
	virtual ~Agent();
	
// actions
	int bid(double current_price);
	Inventory* forsale();
	int accept(double current_price);
	double decideValue(char* product); // would take product as argument in more AI versions
	// int reject(); let reject equal ~accept
	Inventory* findEmptyInv();
	void addItem(Inventory* pos, Inventory* currProdPtr);
	void remItem(Inventory* pos);
	void displayInventory();

// comms
	int tellall();
	int tellone();

// beliefs
	double belief_valueWorth;
	int belief_trust; // this is the trust level peers think of an agent

// possibly should be private
	void move_invItem_ptr();
	
// access to private variables

	void createProduct();
	void agent1_init(); // these 3 functs populates Agent Inventories
	void agent2_init();
	void agent3_init();
	void agent4_init();
	void agent5_init();
	
	void reset_invItem_ptr();

	int Agent::countInventory();
	Inventory* Agent::cheapestItem();
	Inventory* Agent::dearestItem();
	Inventory* Agent::plentifulItem();
	void Agent::inventoryOptimise();

// should be private
	char* currProd;

// function to sort all inventories to get rid of spaces

// private member accessor functions
	char* getname();
	double getfunds();
	Inventory* get_invItem_ptr();
	Inventory* getAgentInvStart();
	int getAgentID();
	void updateFunds(double finalPrice);

private:
	void nameAgent(const char* name);

private:	
	double funds;
	Inventory* invItem_ptr; // pointer to a given index in AgentInventory
	Inventory AgentInventory[5]; // individual agent's inventory
	char name[6]; 
	int agentID;
	
	

//	int keyPress();


	//int betray;
	//int cooperation;
	//int priceHistory[20];
	//int priceStd;
	//int stdConfidence;


};

#endif // !defined(AFX_AGENT_H__76D069E2_07DB_11D5_A2B5_E082D8D8734D__INCLUDED_)
