/*

  Declan McGrath, 0010 4183, MSc. Software Design & Development

  Multi-Agent System Project

  Project Outline:

  Mission Statement-
	This project involves a simulation of a multi-agent environment in which
	n agents play out a buyer seller scenario.

  Running commentry algorithm:
  1. 3 agents declared. They must be registered with a global agent list;
  2. Agents inventories must be filled at start.
  3. A random no genertor selects an agent to sell an item.
	 ... rand(%no_of_agents???)
  4. Selling agent 
			- selects item from inventory
			- decides starting price
			- announces sale
			- a SaleEvent is executed
				- <timer starts, don't worry about this for now>
				- a list of attending agents is maintained ( as seller may only
				  declare to a subset of agents)
				- a bid is (or is not made)
			- final bid definition:
				- when both bidders return a bid status of 0


*/

/*
Note:
	:: used when referring to class
	 . used when referring to an instance.
*/


#include "main.h"

void main(void)
{
	
	srand(time(NULL));
	
	// Declare 3 agents
	
	Agent Agent1;
	Agent1.agent1_init(); // populate individual inventory
	Agent1.reset_invItem_ptr(); // reset pointer to first item in inventory
	agentList[1] = &Agent1;
	
	Agent Agent2;
	Agent2.agent2_init(); // same
	Agent2.reset_invItem_ptr();
	agentList[2] = &Agent2;

	Agent Agent3; 
	Agent3.agent3_init(); // same
	Agent3.reset_invItem_ptr();
	agentList[3] = &Agent3;

	Agent Agent4; 
	Agent4.agent4_init(); // same
	Agent4.reset_invItem_ptr();
	agentList[4] = &Agent4;

	Agent Agent5;
	Agent5.agent5_init(); // same
	Agent5.reset_invItem_ptr();
	agentList[5] = &Agent5;


	SaleEvent Sale1;
					  
	//char *product; forsale() can modify this pointer to return product for sale
				   // for some reason this technoque isn't working

	//note: ag[5] is always the seller	
	int i = ((rand()%5) + 1);
	if (i==1)
	{
		ag[5] = agentList[1];//seller
		ag[4] = agentList[4];
		ag[3] = agentList[3];
		ag[2] = agentList[2];
		ag[1] = agentList[5];
	}
	else if (i==2)
	{
		ag[5] = agentList[2];//seller
		ag[4] = agentList[4];
		ag[3] = agentList[3];
		ag[2] = agentList[5];
		ag[1] = agentList[1];
	}
	
	else if (i==3)
	{
		ag[5] = agentList[3];//seller
		ag[4] = agentList[4];
		ag[3] = agentList[5];
		ag[2] = agentList[2];
		ag[1] = agentList[1];
	}
	
	else if (i==4)
	{
		ag[5] = agentList[4];//seller
		ag[4] = agentList[5];
		ag[3] = agentList[3];
		ag[2] = agentList[2];
		ag[1] = agentList[1];
	}
	
	else if (i==5)
	{
		ag[5] = agentList[5];
		ag[4] = agentList[4];
		ag[3] = agentList[3];//seller
		ag[2] = agentList[2];
		ag[1] = agentList[1];
	}
	else
		cout << "Error choosing seller!!!" << endl;


	for (int a = 1; a <= 5; a++)
	{
		(ag[a])->displayInventory();
	}

	Inventory* currProdPtr = (ag[5])->forsale(); /*item from his inventory*/

	Sale1.current_price = currProdPtr->value;
	Sale1.current_amount = currProdPtr->amount;
	strcpy(Sale1.current_product, currProdPtr->desc);

	(ag[1])->belief_valueWorth = (ag[1])->decideValue(Sale1.current_product); // agent decides max value to bid
	(ag[2])->belief_valueWorth = (ag[2])->decideValue(Sale1.current_product);
	(ag[3])->belief_valueWorth = (ag[3])->decideValue(Sale1.current_product);
	(ag[4])->belief_valueWorth = (ag[4])->decideValue(Sale1.current_product);

	// loop to reiterate bidding, keep going while there were 2 or more bids in last round
	while (Sale1.bid_flag >= 2)
	{
		Sale1.bid_flag = 0;
		
		for (int i=1; i<=4; i++)
		{
			/*
			This code makes sure that the agent in question will only bid
			as long as he didn't make the last bid.
			*/
			if (Sale1.lastbidder != globalAgentList[i])
				Sale1.bid_status = (ag[i])->bid(Sale1.current_price); //addressList[i] is 
															//a pointer to the current agent
			else
				Sale1.bid_status = 0;

			if (Sale1.bid_status == 1)
			{
				Sale1.bid_flag += 1;

				if((ag[5])->accept(Sale1.current_price) == 1) // if bid accepted
				{
					Sale1.lastbid = Sale1.current_price;
					Sale1.lastbidder = globalAgentList[i];
					Sale1.current_price *= 1.1;

				}
			}
		}
	
	}

	double salePrice = Sale1.current_price/1.1; // return to value to winning bid or else too high
	
	// buyer, must be carried out before seller or else currProdPtr values are lost
	double subtract = - salePrice;
	ag[Sale1.lastbidder]->updateFunds(subtract);// debit funds
	Inventory* tempPtr = ag[Sale1.lastbidder]->findEmptyInv(); 
	ag[Sale1.lastbidder]->addItem(tempPtr, currProdPtr);					   // credit inventory
	
	// seller funds/ inventory update
	ag[5]->updateFunds(salePrice); // credit funds
	ag[5]->remItem(currProdPtr);

	// Output to user at end of bidding
	cout << endl << "End of bidding:" << endl;
	cout << "Last bidder is Agent " << Sale1.lastbidder << "." << endl;
	cout << "He's willing to pay " << Sale1.lastbid << " for " << Sale1.current_product << "." << endl<<endl;
	cout<< (ag[1])->getname() <<"'s valued item at " << (ag[1])->belief_valueWorth <<"." << endl; 
	cout<< (ag[2])->getname() <<"'s valued item at " << (ag[2])->belief_valueWorth <<"." << endl;
	cout<< (ag[3])->getname() <<"'s valued item at " << (ag[3])->belief_valueWorth <<"." << endl;
	cout<< (ag[4])->getname() <<"'s valued item at " << (ag[4])->belief_valueWorth <<"." << endl;

	for (a = 1; a <= 5; a++)
	{
		(ag[a])->displayInventory();
	}


}